com.fasterxml.jackson.databind.deser.std

## Class StdDeserializer<T>

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonDeserializer<T>
  - - com.fasterxml.jackson.databind.deser.std.StdDeserializer<T>

- All Implemented Interfaces:
    NullValueProvider, Serializable
  Direct Known Subclasses:
    BeanDeserializerBase, ContainerDeserializerBase, DelegatingDeserializer, EnumSetDeserializer, FailingDeserializer, JsonNodeDeserializer, NullifyingDeserializer, PrimitiveArrayDeserializers, ReferenceTypeDeserializer, StdDelegatingDeserializer, StdNodeBasedDeserializer, StdScalarDeserializer, StringArrayDeserializer, UntypedObjectDeserializer, UntypedObjectDeserializer.Vanilla

      public abstract class StdDeserializer<T>
      extends JsonDeserializer<T>
      implements Serializable

  Base class for common deserializers. Contains shared base functionality for dealing with primitive values, such as (re)parsing from String.
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonDeserializer

      `JsonDeserializer.None`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected Class<?>` | `_valueClass` Type of values this deserializer handles: sometimes exact types, other time most specific supertype of types deserializer handles (which may be as generic as `Object` in some case)
    `protected JavaType` | `_valueType`
    `protected static int` | `F_MASK_ACCEPT_ARRAYS`
    `protected static int` | `F_MASK_INT_COERCIONS` Bitmask that covers `DeserializationFeature.USE_BIG_INTEGER_FOR_INTS` and `DeserializationFeature.USE_LONG_FOR_INTS`, used for more efficient cheks when coercing integral values for untyped deserialization.

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `StdDeserializer(Class<?> vc)`
    `protected` | `StdDeserializer(JavaType valueType)`
    `protected` | `StdDeserializer(StdDeserializer<?> src)` Copy-constructor for sub-classes to use, most often when creating new instances for `ContextualDeserializer`.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected boolean` | `_byteOverflow(int value)`
    `protected String` | `_coercedTypeDesc()` Helper method called to get a description of type into which a scalar value coercion is (most likely) being applied, to be used for constructing exception messages on coerce failure.
    `protected Object` | `_coerceEmptyString(DeserializationContext ctxt, boolean isPrimitive)` Method called when JSON String with value "" (that is, zero length) is encountered.
    `protected Object` | `_coerceIntegral(JsonParser p, DeserializationContext ctxt)` Helper method called in case where an integral number is encountered, but config settings suggest that a coercion may be needed to "upgrade" `Number` into "bigger" type like `Long` or `BigInteger`
    `protected Object` | `_coerceNullToken(DeserializationContext ctxt, boolean isPrimitive)` Method to call when JSON `null` token is encountered.
    `protected Object` | `_coerceTextualNull(DeserializationContext ctxt, boolean isPrimitive)` Method called when JSON String with value "null" is encountered.
    `protected T` | `_deserializeFromArray(JsonParser p, DeserializationContext ctxt)` Helper method that allows easy support for array-related `DeserializationFeature`s `ACCEPT_EMPTY_ARRAY_AS_NULL_OBJECT` and `UNWRAP_SINGLE_VALUE_ARRAYS`: checks for either empty array, or single-value array-wrapped value (respectively), and either reports an exception (if no match, or feature(s) not enabled), or returns appropriate result value.
    `protected T` | `_deserializeFromEmpty(JsonParser p, DeserializationContext ctxt)` Helper method that may be used to support fallback for Empty String / Empty Array non-standard representations; usually for things serialized as JSON Objects.
    `protected T` | `_deserializeWrappedValue(JsonParser p, DeserializationContext ctxt)` Helper called to support `DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS`: default implementation simply calls `JsonDeserializer.deserialize(JsonParser, DeserializationContext)`, but handling may be overridden.
    `protected void` | `_failDoubleToIntCoercion(JsonParser p, DeserializationContext ctxt, String type)`
    `protected NullValueProvider` | `_findNullProvider(DeserializationContext ctxt, BeanProperty prop, Nulls nulls, JsonDeserializer<?> valueDeser)`
    `protected boolean` | `_hasTextualNull(String value)` Helper method called to determine if we are seeing String value of "null", and, further, that it should be coerced to null just like null token.
    `protected boolean` | `_intOverflow(long value)`
    `protected boolean` | `_isEmptyOrTextualNull(String value)`
    `protected boolean` | `_isIntNumber(String text)` Helper method to check whether given text refers to what looks like a clean simple integer number, consisting of optional sign followed by a sequence of digits.
    `protected boolean` | `_isNaN(String text)`
    `protected boolean` | `_isNegInf(String text)`
    `protected boolean` | `_isPosInf(String text)`
    `protected static boolean` | `_neitherNull(Object a, Object b)`
    `protected Number` | `_nonNullNumber(Number n)`
    `protected boolean` | `_parseBooleanFromInt(JsonParser p, DeserializationContext ctxt)`
    `protected boolean` | `_parseBooleanPrimitive(JsonParser p, DeserializationContext ctxt)`
    `protected byte` | `_parseBytePrimitive(JsonParser p, DeserializationContext ctxt)`
    `protected Date` | `_parseDate(JsonParser p, DeserializationContext ctxt)`
    `protected Date` | `_parseDate(String value, DeserializationContext ctxt)`
    `protected Date` | `_parseDateFromArray(JsonParser p, DeserializationContext ctxt)`
    `protected double` | `_parseDoublePrimitive(DeserializationContext ctxt, String text)`
    `protected double` | `_parseDoublePrimitive(JsonParser p, DeserializationContext ctxt)`
    `protected float` | `_parseFloatPrimitive(DeserializationContext ctxt, String text)`
    `protected float` | `_parseFloatPrimitive(JsonParser p, DeserializationContext ctxt)`
    `protected int` | `_parseIntPrimitive(DeserializationContext ctxt, String text)`
    `protected int` | `_parseIntPrimitive(JsonParser p, DeserializationContext ctxt)`
    `protected long` | `_parseLongPrimitive(DeserializationContext ctxt, String text)`
    `protected long` | `_parseLongPrimitive(JsonParser p, DeserializationContext ctxt)`
    `protected short` | `_parseShortPrimitive(JsonParser p, DeserializationContext ctxt)`
    `protected String` | `_parseString(JsonParser p, DeserializationContext ctxt)` Helper method used for accessing String value, if possible, doing necessary conversion or throwing exception as necessary.
    `protected void` | `_reportFailedNullCoerce(DeserializationContext ctxt, boolean state, Enum<?> feature, String inputDesc)`
    `protected boolean` | `_shortOverflow(int value)`
    `protected void` | `_verifyEndArrayForSingle(JsonParser p, DeserializationContext ctxt)`
    `protected void` | `_verifyNullForPrimitive(DeserializationContext ctxt)`
    `protected void` | `_verifyNullForPrimitiveCoercion(DeserializationContext ctxt, String str)`
    `protected void` | `_verifyNullForScalarCoercion(DeserializationContext ctxt, String str)`
    `protected void` | `_verifyNumberForScalarCoercion(DeserializationContext ctxt, JsonParser p)`
    `protected void` | `_verifyStringForScalarCoercion(DeserializationContext ctxt, String str)`
    `Object` | `deserializeWithType(JsonParser p, DeserializationContext ctxt, TypeDeserializer typeDeserializer)` Base implementation that does not assume specific type inclusion mechanism.
    `protected NullValueProvider` | `findContentNullProvider(DeserializationContext ctxt, BeanProperty prop, JsonDeserializer<?> valueDeser)` Method called to find `NullValueProvider` for a contents of a structured primary property (Collection, Map, array), using "content nulls" setting.
    `protected Nulls` | `findContentNullStyle(DeserializationContext ctxt, BeanProperty prop)`
    `protected JsonDeserializer<?>` | `findConvertingContentDeserializer(DeserializationContext ctxt, BeanProperty prop, JsonDeserializer<?> existingDeserializer)` Helper method that can be used to see if specified property has annotation indicating that a converter is to be used for contained values (contents of structured types; array/List/Map values)
    `protected JsonDeserializer<Object>` | `findDeserializer(DeserializationContext ctxt, JavaType type, BeanProperty property)` Helper method used to locate deserializers for properties the type this deserializer handles contains (usually for properties of bean types)
    `protected Boolean` | `findFormatFeature(DeserializationContext ctxt, BeanProperty prop, Class<?> typeForDefaults, JsonFormat.Feature feat)` Convenience method that uses `findFormatOverrides(com.fasterxml.jackson.databind.DeserializationContext, com.fasterxml.jackson.databind.BeanProperty, java.lang.Class<?>)` to find possible defaults and/of overrides, and then calls `JsonFormat.Value.getFeature(feat)` to find whether that feature has been specifically marked as enabled or disabled.
    `protected JsonFormat.Value` | `findFormatOverrides(DeserializationContext ctxt, BeanProperty prop, Class<?> typeForDefaults)` Helper method that may be used to find if this deserializer has specific `JsonFormat` settings, either via property, or through type-specific defaulting.
    `protected NullValueProvider` | `findValueNullProvider(DeserializationContext ctxt, SettableBeanProperty prop, PropertyMetadata propMetadata)` Method called to find `NullValueProvider` for a primary property, using "value nulls" setting.
    `Class<?>` | `getValueClass()` Deprecated. Since 2.3 use `handledType()` instead
    `JavaType` | `getValueType()` Exact structured type this deserializer handles, if known.
    `JavaType` | `getValueType(DeserializationContext ctxt)` Convenience method for getting handled type as `JavaType`, regardless of whether deserializer has one already resolved (and accessible via `getValueType()`) or not: equivalent to:
    `Class<?>` | `handledType()` Method for accessing type of values this deserializer produces.
    `protected void` | `handleMissingEndArrayForSingle(JsonParser p, DeserializationContext ctxt)`
    `protected void` | `handleUnknownProperty(JsonParser p, DeserializationContext ctxt, Object instanceOrClass, String propName)` Method called to deal with a property that did not map to a known Bean property.
    `protected boolean` | `isDefaultDeserializer(JsonDeserializer<?> deserializer)` Method that can be called to determine if given deserializer is the default deserializer Jackson uses; as opposed to a custom deserializer installed by a module or calling application.
    `protected boolean` | `isDefaultKeyDeserializer(KeyDeserializer keyDeser)`
    `protected static double` | `parseDouble(String numStr)` Helper method for encapsulating calls to low-level double value parsing; single place just because we need a work-around that must be applied to all calls.

    - ### Methods inherited from class com.fasterxml.jackson.databind.JsonDeserializer

      `deserialize, deserialize, deserializeWithType, findBackReference, getDelegatee, getEmptyAccessPattern, getEmptyValue, getEmptyValue, getKnownPropertyNames, getNullAccessPattern, getNullValue, getNullValue, getObjectIdReader, isCachable, replaceDelegatee, supportsUpdate, unwrappingDeserializer`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### F_MASK_INT_COERCIONS

          protected static final int F_MASK_INT_COERCIONS

      Bitmask that covers `DeserializationFeature.USE_BIG_INTEGER_FOR_INTS` and `DeserializationFeature.USE_LONG_FOR_INTS`, used for more efficient cheks when coercing integral values for untyped deserialization.
      Since:
        2.6

    - #### F_MASK_ACCEPT_ARRAYS

          protected static final int F_MASK_ACCEPT_ARRAYS

    - #### _valueClass

          protected final Class<?> _valueClass

      Type of values this deserializer handles: sometimes exact types, other time most specific supertype of types deserializer handles (which may be as generic as `Object` in some case)

    - #### _valueType

          protected final JavaType _valueType

  - ### Constructor Detail

    - #### StdDeserializer

          protected StdDeserializer(Class<?> vc)

    - #### StdDeserializer

          protected StdDeserializer(JavaType valueType)

    - #### StdDeserializer

          protected StdDeserializer(StdDeserializer<?> src)

      Copy-constructor for sub-classes to use, most often when creating new instances for `ContextualDeserializer`.
      Since:
        2.5

  - ### Method Detail

    - #### handledType

          public Class<?> handledType()

      Description copied from class: `JsonDeserializer`
      Method for accessing type of values this deserializer produces. Note that this information is not guaranteed to be exact -- it may be a more generic (super-type) -- but it should not be incorrect (return a non-related type).

      Default implementation will return null, which means almost same same as returning `Object.class` would; that is, that nothing is known about handled type.

      Overrides:
        `handledType` in class `JsonDeserializer<T>`

    - #### getValueClass

          @Deprecated
          public final Class<?> getValueClass()

      Deprecated. Since 2.3 use `handledType()` instead

    - #### getValueType

          public JavaType getValueType()

      Exact structured type this deserializer handles, if known.

    - #### getValueType

          public JavaType getValueType(DeserializationContext ctxt)

      Convenience method for getting handled type as `JavaType`, regardless of whether deserializer has one already resolved (and accessible via `getValueType()`) or not: equivalent to:

             if (getValueType() != null) {
                  return getValueType();
             }
             return ctxt.constructType(handledType());

      Since:
        2.10

    - #### isDefaultDeserializer

          protected boolean isDefaultDeserializer(JsonDeserializer<?> deserializer)

      Method that can be called to determine if given deserializer is the default deserializer Jackson uses; as opposed to a custom deserializer installed by a module or calling application. Determination is done using `JacksonStdImpl` annotation on deserializer class.

    - #### isDefaultKeyDeserializer

          protected boolean isDefaultKeyDeserializer(KeyDeserializer keyDeser)

    - #### deserializeWithType

          public Object deserializeWithType(JsonParser p,
                                            DeserializationContext ctxt,
                                            TypeDeserializer typeDeserializer)
                                     throws IOException

      Base implementation that does not assume specific type inclusion mechanism. Sub-classes are expected to override this method if they are to handle type information.
      Overrides:
        `deserializeWithType` in class `JsonDeserializer<T>`
        `typeDeserializer` - Deserializer to use for handling type information
      Throws:
        `IOException`

    - #### _parseBooleanPrimitive

          protected final boolean _parseBooleanPrimitive(JsonParser p,
                                                         DeserializationContext ctxt)
                                                  throws IOException

      Throws:
        `IOException`

    - #### _parseBooleanFromInt

          protected boolean _parseBooleanFromInt(JsonParser p,
                                                 DeserializationContext ctxt)
                                          throws IOException

      Throws:
        `IOException`

    - #### _parseBytePrimitive

          protected final byte _parseBytePrimitive(JsonParser p,
                                                   DeserializationContext ctxt)
                                            throws IOException

      Throws:
        `IOException`

    - #### _parseShortPrimitive

          protected final short _parseShortPrimitive(JsonParser p,
                                                     DeserializationContext ctxt)
                                              throws IOException

      Throws:
        `IOException`

    - #### _parseIntPrimitive

          protected final int _parseIntPrimitive(JsonParser p,
                                                 DeserializationContext ctxt)
                                          throws IOException

      Throws:
        `IOException`

    - #### _parseIntPrimitive

          protected final int _parseIntPrimitive(DeserializationContext ctxt,
                                                 String text)
                                          throws IOException

      Throws:
        `IOException`
      Since:
        2.9

    - #### _parseLongPrimitive

          protected final long _parseLongPrimitive(JsonParser p,
                                                   DeserializationContext ctxt)
                                            throws IOException

      Throws:
        `IOException`

    - #### _parseLongPrimitive

          protected final long _parseLongPrimitive(DeserializationContext ctxt,
                                                   String text)
                                            throws IOException

      Throws:
        `IOException`
      Since:
        2.9

    - #### _parseFloatPrimitive

          protected final float _parseFloatPrimitive(JsonParser p,
                                                     DeserializationContext ctxt)
                                              throws IOException

      Throws:
        `IOException`

    - #### _parseFloatPrimitive

          protected final float _parseFloatPrimitive(DeserializationContext ctxt,
                                                     String text)
                                              throws IOException

      Throws:
        `IOException`
      Since:
        2.9

    - #### _parseDoublePrimitive

          protected final double _parseDoublePrimitive(JsonParser p,
                                                       DeserializationContext ctxt)
                                                throws IOException

      Throws:
        `IOException`

    - #### _parseDoublePrimitive

          protected final double _parseDoublePrimitive(DeserializationContext ctxt,
                                                       String text)
                                                throws IOException

      Throws:
        `IOException`
      Since:
        2.9

    - #### _parseDate

          protected Date _parseDate(JsonParser p,
                                    DeserializationContext ctxt)
                             throws IOException

      Throws:
        `IOException`

    - #### _parseDateFromArray

          protected Date _parseDateFromArray(JsonParser p,
                                             DeserializationContext ctxt)
                                      throws IOException

      Throws:
        `IOException`

    - #### _parseDate

          protected Date _parseDate(String value,
                                    DeserializationContext ctxt)
                             throws IOException

      Throws:
        `IOException`
      Since:
        2.8

    - #### parseDouble

          protected static final double parseDouble(String numStr)
                                             throws NumberFormatException

      Helper method for encapsulating calls to low-level double value parsing; single place just because we need a work-around that must be applied to all calls.
      Throws:
        `NumberFormatException`

    - #### _parseString

          protected final String _parseString(JsonParser p,
                                              DeserializationContext ctxt)
                                       throws IOException

      Helper method used for accessing String value, if possible, doing necessary conversion or throwing exception as necessary.
      Throws:
        `IOException`
      Since:
        2.1

    - #### _deserializeFromEmpty

          protected T _deserializeFromEmpty(JsonParser p,
                                            DeserializationContext ctxt)
                                     throws IOException

      Helper method that may be used to support fallback for Empty String / Empty Array non-standard representations; usually for things serialized as JSON Objects.
      Throws:
        `IOException`
      Since:
        2.5

    - #### _hasTextualNull

          protected boolean _hasTextualNull(String value)

      Helper method called to determine if we are seeing String value of "null", and, further, that it should be coerced to null just like null token.
      Since:
        2.3

    - #### _isEmptyOrTextualNull

          protected boolean _isEmptyOrTextualNull(String value)

      Since:
        2.9

    - #### _isNegInf

          protected final boolean _isNegInf(String text)

    - #### _isPosInf

          protected final boolean _isPosInf(String text)

    - #### _isNaN

          protected final boolean _isNaN(String text)

    - #### _deserializeFromArray

          protected T _deserializeFromArray(JsonParser p,
                                            DeserializationContext ctxt)
                                     throws IOException

      Helper method that allows easy support for array-related `DeserializationFeature`s `ACCEPT_EMPTY_ARRAY_AS_NULL_OBJECT` and `UNWRAP_SINGLE_VALUE_ARRAYS`: checks for either empty array, or single-value array-wrapped value (respectively), and either reports an exception (if no match, or feature(s) not enabled), or returns appropriate result value.

      This method should NOT be called if Array representation is explicitly supported for type: it should only be called in case it is otherwise unrecognized.

      NOTE: in case of unwrapped single element, will handle actual decoding by calling `_deserializeWrappedValue(com.fasterxml.jackson.core.JsonParser, com.fasterxml.jackson.databind.DeserializationContext)`, which by default calls `JsonDeserializer.deserialize(JsonParser, DeserializationContext)`.

      Throws:
        `IOException`
      Since:
        2.9

    - #### _deserializeWrappedValue

          protected T _deserializeWrappedValue(JsonParser p,
                                               DeserializationContext ctxt)
                                        throws IOException

      Helper called to support `DeserializationFeature.UNWRAP_SINGLE_VALUE_ARRAYS`: default implementation simply calls `JsonDeserializer.deserialize(JsonParser, DeserializationContext)`, but handling may be overridden.
      Throws:
        `IOException`
      Since:
        2.9

    - #### _failDoubleToIntCoercion

          protected void _failDoubleToIntCoercion(JsonParser p,
                                                  DeserializationContext ctxt,
                                                  String type)
                                           throws IOException

      Throws:
        `IOException`

    - #### _coerceIntegral

          protected Object _coerceIntegral(JsonParser p,
                                           DeserializationContext ctxt)
                                    throws IOException

      Helper method called in case where an integral number is encountered, but config settings suggest that a coercion may be needed to "upgrade" `Number` into "bigger" type like `Long` or `BigInteger`
      Throws:
        `IOException`
      Since:
        2.6
      See Also:
        `DeserializationFeature.USE_BIG_INTEGER_FOR_INTS`, `DeserializationFeature.USE_LONG_FOR_INTS`

    - #### _coerceNullToken

          protected Object _coerceNullToken(DeserializationContext ctxt,
                                            boolean isPrimitive)
                                     throws JsonMappingException

      Method to call when JSON `null` token is encountered. Note: only called when this deserializer encounters it but NOT when reached via property
      Throws:
        `JsonMappingException`
      Since:
        2.9

    - #### _coerceTextualNull

          protected Object _coerceTextualNull(DeserializationContext ctxt,
                                              boolean isPrimitive)
                                       throws JsonMappingException

      Method called when JSON String with value "null" is encountered.
      Throws:
        `JsonMappingException`
      Since:
        2.9

    - #### _coerceEmptyString

          protected Object _coerceEmptyString(DeserializationContext ctxt,
                                              boolean isPrimitive)
                                       throws JsonMappingException

      Method called when JSON String with value "" (that is, zero length) is encountered.
      Throws:
        `JsonMappingException`
      Since:
        2.9

    - #### _verifyNullForPrimitive

          protected final void _verifyNullForPrimitive(DeserializationContext ctxt)
                                                throws JsonMappingException

      Throws:
        `JsonMappingException`

    - #### _verifyNullForPrimitiveCoercion

          protected final void _verifyNullForPrimitiveCoercion(DeserializationContext ctxt,
                                                               String str)
                                                        throws JsonMappingException

      Throws:
        `JsonMappingException`

    - #### _verifyNullForScalarCoercion

          protected final void _verifyNullForScalarCoercion(DeserializationContext ctxt,
                                                            String str)
                                                     throws JsonMappingException

      Throws:
        `JsonMappingException`

    - #### _verifyStringForScalarCoercion

          protected void _verifyStringForScalarCoercion(DeserializationContext ctxt,
                                                        String str)
                                                 throws JsonMappingException

      Throws:
        `JsonMappingException`

    - #### _verifyNumberForScalarCoercion

          protected void _verifyNumberForScalarCoercion(DeserializationContext ctxt,
                                                        JsonParser p)
                                                 throws IOException

      Throws:
        `IOException`

    - #### _reportFailedNullCoerce

          protected void _reportFailedNullCoerce(DeserializationContext ctxt,
                                                 boolean state,
                                                 Enum<?> feature,
                                                 String inputDesc)
                                          throws JsonMappingException

      Throws:
        `JsonMappingException`

    - #### _coercedTypeDesc

          protected String _coercedTypeDesc()

      Helper method called to get a description of type into which a scalar value coercion is (most likely) being applied, to be used for constructing exception messages on coerce failure.
      Returns:
        Message with backtick-enclosed name of type this deserializer supports
      Since:
        2.9

    - #### findDeserializer

          protected JsonDeserializer<Object> findDeserializer(DeserializationContext ctxt,
                                                              JavaType type,
                                                              BeanProperty property)
                                                       throws JsonMappingException

      Helper method used to locate deserializers for properties the type this deserializer handles contains (usually for properties of bean types)
      Parameters:
        `type` - Type of property to deserialize
        `property` - Actual property object (field, method, constuctor parameter) used for passing deserialized values; provided so deserializer can be contextualized if necessary
      Throws:
        `JsonMappingException`

    - #### _isIntNumber

          protected final boolean _isIntNumber(String text)

      Helper method to check whether given text refers to what looks like a clean simple integer number, consisting of optional sign followed by a sequence of digits.

    - #### findConvertingContentDeserializer

          protected JsonDeserializer<?> findConvertingContentDeserializer(DeserializationContext ctxt,
                                                                          BeanProperty prop,
                                                                          JsonDeserializer<?> existingDeserializer)
                                                                   throws JsonMappingException

      Helper method that can be used to see if specified property has annotation indicating that a converter is to be used for contained values (contents of structured types; array/List/Map values)
      Parameters:
        `existingDeserializer` - (optional) configured content serializer if one already exists.
      Throws:
        `JsonMappingException`
      Since:
        2.2

    - #### findFormatOverrides

          protected JsonFormat.Value findFormatOverrides(DeserializationContext ctxt,
                                                         BeanProperty prop,
                                                         Class<?> typeForDefaults)

      Helper method that may be used to find if this deserializer has specific `JsonFormat` settings, either via property, or through type-specific defaulting.
      Parameters:
        `typeForDefaults` - Type (erased) used for finding default format settings, if any
      Since:
        2.7

    - #### findFormatFeature

          protected Boolean findFormatFeature(DeserializationContext ctxt,
                                              BeanProperty prop,
                                              Class<?> typeForDefaults,
                                              JsonFormat.Feature feat)

      Convenience method that uses `findFormatOverrides(com.fasterxml.jackson.databind.DeserializationContext, com.fasterxml.jackson.databind.BeanProperty, java.lang.Class<?>)` to find possible defaults and/of overrides, and then calls `JsonFormat.Value.getFeature(feat)` to find whether that feature has been specifically marked as enabled or disabled.
      Parameters:
        `typeForDefaults` - Type (erased) used for finding default format settings, if any
      Since:
        2.7

    - #### findValueNullProvider

          protected final NullValueProvider findValueNullProvider(DeserializationContext ctxt,
                                                                  SettableBeanProperty prop,
                                                                  PropertyMetadata propMetadata)
                                                           throws JsonMappingException

      Method called to find `NullValueProvider` for a primary property, using "value nulls" setting. If no provider found (not defined, or is "skip"), will return `null`.
      Throws:
        `JsonMappingException`
      Since:
        2.9

    - #### findContentNullProvider

          protected NullValueProvider findContentNullProvider(DeserializationContext ctxt,
                                                              BeanProperty prop,
                                                              JsonDeserializer<?> valueDeser)
                                                       throws JsonMappingException

      Method called to find `NullValueProvider` for a contents of a structured primary property (Collection, Map, array), using "content nulls" setting. If no provider found (not defined), will return given value deserializer (which is a null value provider itself).
      Throws:
        `JsonMappingException`
      Since:
        2.9

    - #### findContentNullStyle

          protected Nulls findContentNullStyle(DeserializationContext ctxt,
                                               BeanProperty prop)
                                        throws JsonMappingException

      Throws:
        `JsonMappingException`

    - #### _findNullProvider

          protected final NullValueProvider _findNullProvider(DeserializationContext ctxt,
                                                              BeanProperty prop,
                                                              Nulls nulls,
                                                              JsonDeserializer<?> valueDeser)
                                                       throws JsonMappingException

      Throws:
        `JsonMappingException`

    - #### handleUnknownProperty

          protected void handleUnknownProperty(JsonParser p,
                                               DeserializationContext ctxt,
                                               Object instanceOrClass,
                                               String propName)
                                        throws IOException

      Method called to deal with a property that did not map to a known Bean property. Method can deal with the problem as it sees fit (ignore, throw exception); but if it does return, it has to skip the matching Json content parser has.
      Parameters:
        `p` - Parser that points to value of the unknown property
        `ctxt` - Context for deserialization; allows access to the parser, error reporting functionality
        `instanceOrClass` - Instance that is being populated by this deserializer, or if not known, Class that would be instantiated. If null, will assume type is what `getValueClass()` returns.
        `propName` - Name of the property that cannot be mapped
      Throws:
        `IOException`

    - #### handleMissingEndArrayForSingle

          protected void handleMissingEndArrayForSingle(JsonParser p,
                                                        DeserializationContext ctxt)
                                                 throws IOException

      Throws:
        `IOException`

    - #### _verifyEndArrayForSingle

          protected void _verifyEndArrayForSingle(JsonParser p,
                                                  DeserializationContext ctxt)
                                           throws IOException

      Throws:
        `IOException`

    - #### _neitherNull

          protected static final boolean _neitherNull(Object a,
                                                      Object b)

      Since:
        2.9

    - #### _byteOverflow

          protected final boolean _byteOverflow(int value)

      Since:
        2.9

    - #### _shortOverflow

          protected final boolean _shortOverflow(int value)

      Since:
        2.9

    - #### _intOverflow

          protected final boolean _intOverflow(long value)

      Since:
        2.9

    - #### _nonNullNumber

          protected Number _nonNullNumber(Number n)

      Since:
        2.9

Copyright © 2008–2019 FasterXML. All rights reserved.